<template>
  <q-page class="q-ma-xl">
    <q-form
      @submit="!selectedRow.id ? addTodo() : updateTodo()"
      class="q-ma-md"
    >
      <q-input v-model="form.title" label="Input Field" />
      <q-btn
        type="submit"
        :label="!selectedRow.id ? 'Submit' : 'Update'"
        color="primary"
      />
      <q-btn
        :loading="deleteBtnLoadingState"
        v-if="selectedRow.id"
        @click="deleteTodo()"
        class="q-ml-md"
        label="Delete"
        color="negative"
      />
    </q-form>

    <q-table
      title="Todos"
      :rows="rows"
      :columns="columns"
      row-key="name"
      @row-click="onRowClick"
    />
  </q-page>
</template>

<script setup>
import { ref, onMounted } from "vue";
import axios from "axios";

// on mount
onMounted(() => {
  getTodos();
});

// table data
let rows = ref([]);
let columns = ref([
  {
    name: "title",
    label: "Title",
    align: "left",
    field: "title",
  },
  {
    name: "completed",
    label: "Completed",
    align: "left",
    field: "completed",
  },
]);

// form data
let btnLoadingState = ref(false);
let selectedRow = ref({});
let deleteBtnLoadingState = ref(false);
let form = ref({
  userId: 1,
  title: null,
  completed: false,
});

// get todos from api
const getTodos = () => {
  axios.get("https://jsonplaceholder.typicode.com/todos").then((response) => {
    rows.value = response.data;
  });
};

// add todo
const addTodo = () => {
  btnLoadingState.value = true;
  axios
    .post("https://jsonplaceholder.typicode.com/todos", form.value)
    .then((response) => {
      // if response is success
      if (response.status === 201) {
        // add new todo to table
        rows.value.unshift(response.data);
        form.value.title = null;
      }
      btnLoadingState.value = false;
    });
};

// on row click
const onRowClick = (evt, row) => {
  selectedRow.value = row;
  form.value.title = row.title;
};

// update todo
const updateTodo = () => {
  btnLoadingState.value = true;
  axios
    .put(`https://jsonplaceholder.typicode.com/todos/${selectedRow.value.id}`, {
      title: form.value.title,
    })
    .then((response) => {
      // if response is success
      if (response.status === 200) {
        // get index of selected row
        let index = rows.value.findIndex(
          (row) => row.id === selectedRow.value.id
        );

        // update title of selected row
        rows.value[index].title = response.data.title;
        form.value.title = null;
        selectedRow.value = {};
      }
      btnLoadingState.value = false;
    });
};

// delete todo
const deleteTodo = () => {
  deleteBtnLoadingState.value = true;
  axios
    .delete(
      `https://jsonplaceholder.typicode.com/todos/${selectedRow.value.id}`
    )
    .then((response) => {
      // if response is success
      if (response.status === 200) {
        // remove selected row from table
        rows.value = rows.value.filter(
          (row) => row.id !== selectedRow.value.id
        );
        form.value.title = null;
      }
      deleteBtnLoadingState.value = false;
    });
};
</script>
